Index: /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15273)
@@ -52,5 +52,6 @@
       //TestExpressionDependencies();
       //TestSplitLogic();
-      TestStringBuilder();
+      //TestStringBuilder();
+      TestRandomReset();
 
       Console.WriteLine("\nPress any key to continue...");
@@ -67,4 +68,16 @@
       // false
       var equal = ReferenceEquals(s1, s2);
+    }
+
+    private static void TestRandomReset() {
+      var random = new MersenneTwister(1000);
+
+      var x = random.Next();
+      random.Reset();
+      var y = random.Next();
+
+      if (x != y) {
+        throw new InvalidOperationException();
+      }
     }
 
@@ -422,5 +435,5 @@
       for (var i = 0; i < 60000000; i++) {
         interpreter.Run(program);
-        interpreter.Clear();
+        interpreter.ClearStacks();
       }
       sw.Stop();
@@ -442,5 +455,5 @@
           for (var j = 0; j < amount; j++) {
             interpreter.Run(program);
-            interpreter.Clear();
+            interpreter.ClearStacks();
           }
         }
@@ -552,5 +565,5 @@
       for (var i = 0; i < iterations; i++) {
         var interpreter = new PushInterpreter();
-        interpreter.Clear();
+        interpreter.ClearStacks();
       }
       sw.Stop();
@@ -562,5 +575,5 @@
       for (var i = 0; i < iterations; i++) {
         using (var interpreter = pool.Create()) {
-          interpreter.Clear();
+          interpreter.ClearStacks();
         }
       }
@@ -597,4 +610,6 @@
     public int Age { get; set; }
 
+    public void Init() { }
+
     public void Reset() {
       Age = default(int);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15273)
@@ -53,5 +53,5 @@
     public ExampleArgumentType[] OutputArgumentTypes { get; set; }
 
-    public int TotalIntputArgumentCount { get { return InputArgumentTypes.Length; } }
+    public int TotalInputArgumentCount { get { return InputArgumentTypes.Length; } }
     public int TotalOutputArgumentCount { get { return OutputArgumentTypes.Length; } }
     public int TotalArgumentCount { get { return InputArgumentTypes.Length + OutputArgumentTypes.Length; } }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/ErcOptionConvertible.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/ErcOptionConvertible.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/ErcOptionConvertible.cs	(revision 15273)
@@ -7,5 +7,5 @@
   using HeuristicLab.Core;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Weighted;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Extensions;
 
   [StorableClass]
@@ -93,5 +93,5 @@
       var ercValueItem = list
         .Where(item => item.IsEnabled)
-        .RandomWeightedOrDefault(random);
+        .RandomWeightedOrDefault(random, x => x.Weight);
 
       return ercValueItem == null
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/EnumerableExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/EnumerableExtensions.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/EnumerableExtensions.cs	(revision 15273)
@@ -0,0 +1,29 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Extensions {
+  using System;
+  using System.Collections.Generic;
+  using System.Linq;
+
+  using HeuristicLab.Core;
+  using HeuristicLab.Random;
+
+  public static class EnumerableExtensions {
+    public static T RandomWeightedOrDefault<T>(this IEnumerable<T> items, IRandom random, Func<T, double> weightResolver) {
+      random = random ?? new MersenneTwister();
+      var totalWeight = items.Sum(weightResolver);
+
+      // The weight we are after...
+      var itemWeightIndex = random.NextDouble() * totalWeight;
+      var currentWeightIndex = 0d;
+
+      foreach (var item in items) {
+        currentWeightIndex += weightResolver(item);
+
+        // If we've hit or passed the weight we are after for this item then it's the one we want....
+        if (currentWeightIndex >= itemWeightIndex)
+          return item;
+      }
+
+      return default(T);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj	(revision 15273)
@@ -123,9 +123,9 @@
     <Compile Include="Erc\String\StringRandomErc.cs" />
     <Compile Include="Erc\String\StringErcOptions.cs" />
+    <Compile Include="Extensions\EnumerableExtensions.cs" />
     <Compile Include="Generators\StringGenerator.cs" />
     <Compile Include="Weighted\IWeighted.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Weighted\WeightedExtensions.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15273)
@@ -122,4 +122,6 @@
       <DependentUpon>Resources.resx</DependentUpon>
     </Compile>
+    <Compile Include="Push\Analyzer\IIndividualZeroErrorAnalyzer.cs" />
+    <Compile Include="Push\Analyzer\IndividualZeroErrorAnalyzer.cs" />
     <Compile Include="Push\Analyzer\IPushExpressionAnalyzer.cs" />
     <Compile Include="Push\Analyzer\PushExpressionFrequencyAnalyzer.cs" />
@@ -195,5 +197,4 @@
     <Compile Include="Push\Extensions\ControlExntensions.cs" />
     <Compile Include="Push\Extensions\EnumExtensions.cs" />
-    <Compile Include="Push\Extensions\ProblemDataExtensions.cs" />
     <Compile Include="Push\Extensions\LongExtensions.cs" />
     <Compile Include="Push\Extensions\RandomExtensions.cs" />
@@ -212,4 +213,5 @@
     <Compile Include="Push\Interpreter\PushInterpreter.cs" />
     <Compile Include="Push\Interpreter\PushInterpreterPool.cs" />
+    <Compile Include="Push\ObjectPools\Random\SeededRandomPool.cs" />
     <Compile Include="Push\ObjectPools\StringBuilderPool.cs" />
     <Compile Include="Push\Parser\PushParser.cs" />
@@ -228,4 +230,6 @@
     <Compile Include="Push\Selector\LexicaseSelector.cs" />
     <Compile Include="Push\Simplifier\Simplifier.cs" />
+    <Compile Include="Push\SolutionCreator\PushSolutionCreator.cs" />
+    <Compile Include="Push\SolutionCreator\PushSolutionEncoding.cs" />
     <Compile Include="Push\Stack\IPrintStack.cs" />
     <Compile Include="Push\Stack\IPushStack.cs" />
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IIndividualZeroErrorAnalyzer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IIndividualZeroErrorAnalyzer.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IIndividualZeroErrorAnalyzer.cs	(revision 15273)
@@ -0,0 +1,7 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer {
+  using HeuristicLab.Optimization;
+
+  public interface IIndividualZeroErrorAnalyzer : IAnalyzer {
+
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs	(revision 15273)
@@ -0,0 +1,135 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer {
+
+  using HeuristicLab.Analysis;
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Data;
+  using HeuristicLab.Operators;
+  using HeuristicLab.Optimization;
+  using HeuristicLab.Parameters;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem;
+
+  /// <summary>
+  /// An operater that tracks the count of individuals with zero error on the cases
+  /// </summary>
+  [Item("IndividualZeroErrorAnalyzer", "An operater that tracks the count of individuals with zero error on the cases")]
+  [StorableClass]
+  public class IndividualZeroErrorAnalyzer : SingleSuccessorOperator, IIndividualZeroErrorAnalyzer {
+    private const string RESULTS_PARAMETER_NAME = "Results";
+    private const string INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME = "ZeroErrorIndividualsPerCase";
+
+    private const string RESULT_PARAMETER_NAME = "Zero Error Individuals Per Case";
+    private const string RESULT_PARAMETER_DESCRIPTION = "Relative frequency of instructions aggregated over the whole population.";
+    private const string Y_AXIS_TITLE = "Count if zero error individuals";
+    private const string X_AXIS_TITLE = "Case Index";
+    private const string ROW_NAME = "Cases";
+
+    public IndividualZeroErrorAnalyzer() {
+      Parameters.Add(new LookupParameter<DataTable>(
+        INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME,
+        "The data table to store the count of individuals with zero error."));
+
+      Parameters.Add(new LookupParameter<ResultCollection>(
+        RESULTS_PARAMETER_NAME,
+        "The result collection where the symbol frequencies should be stored."));
+
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleArray>(
+       PushProblem.CaseQualitiesScopeParameterName,
+       "The quality of every single training case for each individual."));
+    }
+
+    [StorableConstructor]
+    public IndividualZeroErrorAnalyzer(bool deserializing) : base(deserializing) { }
+
+    public IndividualZeroErrorAnalyzer(IndividualZeroErrorAnalyzer origin, Cloner cloner) : base(origin, cloner) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new IndividualZeroErrorAnalyzer(this, cloner);
+    }
+
+    public bool EnabledByDefault { get { return true; } }
+
+    public ILookupParameter<DataTable> IndividualZeroErrorParameter
+    {
+      get { return (ILookupParameter<DataTable>)Parameters[INDIVIDUAL_ZERO_ERROR_PARAMETER_NAME]; }
+    }
+
+    public ILookupParameter<ResultCollection> ResultsParameter
+    {
+      get { return (ILookupParameter<ResultCollection>)Parameters[RESULTS_PARAMETER_NAME]; }
+    }
+
+    public ILookupParameter<ItemArray<DoubleArray>> CaseQualitiesParameter
+    {
+      get { return (ILookupParameter<ItemArray<DoubleArray>>)Parameters[PushProblem.CaseQualitiesScopeParameterName]; }
+    }
+
+    public override IOperation Apply() {
+      var caseQualitiesPerIndividual = CaseQualitiesParameter.ActualValue;
+      var caseCount = caseQualitiesPerIndividual[0].Length;
+
+      var results = ResultsParameter.ActualValue;
+      var individualZeroErrorCounts = IndividualZeroErrorParameter.ActualValue;
+
+      if (individualZeroErrorCounts == null) {
+        individualZeroErrorCounts = new DataTable(
+         RESULT_PARAMETER_NAME,
+         RESULT_PARAMETER_DESCRIPTION) {
+          VisualProperties = {
+            YAxisTitle = Y_AXIS_TITLE,
+            XAxisTitle = X_AXIS_TITLE,
+            XAxisMinimumFixedValue = 0,
+            XAxisMaximumFixedValue = caseCount,
+            XAxisMaximumAuto = false,
+            XAxisMinimumAuto = false,
+          }
+        };
+
+        IndividualZeroErrorParameter.ActualValue = individualZeroErrorCounts;
+      }
+
+      if (!results.ContainsKey(RESULT_PARAMETER_NAME)) {
+        results.Add(new Result(RESULT_PARAMETER_NAME, individualZeroErrorCounts));
+      }
+
+      DataRow row;
+      if (!individualZeroErrorCounts.Rows.TryGetValue(ROW_NAME, out row)) {
+        row = new DataRow(ROW_NAME) {
+          VisualProperties = {
+              StartIndexZero = true,
+              IsVisibleInLegend = false,
+              ChartType = DataRowVisualProperties.DataRowChartType.Bars,
+            }
+        };
+
+        individualZeroErrorCounts.Rows.Add(row);
+      }
+
+      var caseCountChanged = row.Values.Count != caseCount;
+
+      if (caseCountChanged) {
+        individualZeroErrorCounts.VisualProperties.XAxisMaximumFixedValue = caseCount;
+        row.Values.Clear();
+      }
+
+      for (var i = 0; i < caseCount; i++) {
+        var count = 0;
+
+        for (var j = 0; j < caseQualitiesPerIndividual.Length; j++) {
+          var caseQuality = caseQualitiesPerIndividual[j][i];
+
+          if (caseQuality == 0.0)
+            count++;
+        }
+
+        if (caseCountChanged)
+          row.Values.Add(count);
+        else
+          row.Values[i] = count;
+      }
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/PushExpressionFrequencyAnalyzer.cs	(revision 15273)
@@ -12,7 +12,9 @@
   using HeuristicLab.Parameters;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Individual;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.ObjectPools.Random;
 
   /// <summary>
@@ -22,18 +24,24 @@
   [StorableClass]
   public class PushExpressionFrequencyAnalyzer : SingleSuccessorOperator, IPushExpressionAnalyzer {
+    private readonly SeededRandomPool randomPool = new SeededRandomPool();
 
-    private const string PushConfigurationParameterName = "PushConfiguration";
-    private const string IntegerVectorParameterName = "IntegerVector";
-    private const string ResultsParameterName = "Results";
-    private const string ExpressionFrequenciesParameterName = "InstructionFrequencies";
-    private const string AggregateStackTypesParameterName = "Aggregate stack types";
+    private const string PUSH_CONFIGURATION_PARAMETER_NAME = "PushConfiguration";
+    private const string INTEGER_VECTOR_PARAMETER_NAME = "IntegerVector";
+    private const string RESULTS_PARAMETER_NAME = "Results";
+    private const string EXPRESSION_FREQUENCIES_PARAMETER_NAME = "InstructionFrequencies";
+    private const string AGGREGATE_STACK_TYPES_PARAMETER_NAME = "Aggregate stack types";
+    private const string IN_EXPRESSION_GROUP_NAME = "IN";
+    private const string RANDOM_PARAMETER_NAME = "Random";
+    private const string RESULT_PARAMETER_NAME = "Instruction frequencies";
+    private const string RESULT_PARAMETER_DESCRIPTION = "Relative frequency of instructions aggregated over the whole population.";
+    private const string Y_AXIS_TITLE = "Relative Instruction Frequency";
 
     public PushExpressionFrequencyAnalyzer() {
-      Parameters.Add(new LookupParameter<IReadOnlyPushConfiguration>(PushConfigurationParameterName, "The current specified push configuration."));
-      Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>(IntegerVectorParameterName, "The integer vectors to analyze."));
-      Parameters.Add(new LookupParameter<DataTable>(ExpressionFrequenciesParameterName, "The data table to store the instruction frequencies."));
-      Parameters.Add(new LookupParameter<ResultCollection>(ResultsParameterName, "The result collection where the symbol frequencies should be stored."));
+      Parameters.Add(new LookupParameter<IReadOnlyPushConfiguration>(PUSH_CONFIGURATION_PARAMETER_NAME, "The current specified push configuration."));
+      Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>(INTEGER_VECTOR_PARAMETER_NAME, "The integer vectors to analyze."));
+      Parameters.Add(new LookupParameter<DataTable>(EXPRESSION_FREQUENCIES_PARAMETER_NAME, "The data table to store the instruction frequencies."));
+      Parameters.Add(new LookupParameter<ResultCollection>(RESULTS_PARAMETER_NAME, "The result collection where the symbol frequencies should be stored."));
 
-      Parameters.Add(new FixedValueParameter<BoolValue>(AggregateStackTypesParameterName, "Determines if expressions should be aggregated by their primary stack type.", new BoolValue(true)));
+      Parameters.Add(new FixedValueParameter<BoolValue>(AGGREGATE_STACK_TYPES_PARAMETER_NAME, "Determines if expressions should be aggregated by their primary stack type.", new BoolValue(true)));
     }
 
@@ -51,25 +59,30 @@
     public ILookupParameter<IReadOnlyPushConfiguration> PushConfigurationParameter
     {
-      get { return (ILookupParameter<IReadOnlyPushConfiguration>)Parameters[PushConfigurationParameterName]; }
+      get { return (ILookupParameter<IReadOnlyPushConfiguration>)Parameters[PUSH_CONFIGURATION_PARAMETER_NAME]; }
     }
 
     public IScopeTreeLookupParameter<IntegerVector> IntegerVectorParameter
     {
-      get { return (IScopeTreeLookupParameter<IntegerVector>)Parameters[IntegerVectorParameterName]; }
+      get { return (IScopeTreeLookupParameter<IntegerVector>)Parameters[INTEGER_VECTOR_PARAMETER_NAME]; }
     }
 
     public ILookupParameter<DataTable> ExpressionFrequenciesParameter
     {
-      get { return (ILookupParameter<DataTable>)Parameters[ExpressionFrequenciesParameterName]; }
+      get { return (ILookupParameter<DataTable>)Parameters[EXPRESSION_FREQUENCIES_PARAMETER_NAME]; }
+    }
+
+    public ILookupParameter<IRandom> RandomParameter
+    {
+      get { return (ILookupParameter<IRandom>)Parameters[RANDOM_PARAMETER_NAME]; }
     }
 
     public ILookupParameter<ResultCollection> ResultsParameter
     {
-      get { return (ILookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
+      get { return (ILookupParameter<ResultCollection>)Parameters[RESULTS_PARAMETER_NAME]; }
     }
 
     public IValueParameter<BoolValue> AggregateStackTypesParameter
     {
-      get { return (IValueParameter<BoolValue>)Parameters[AggregateStackTypesParameterName]; }
+      get { return (IValueParameter<BoolValue>)Parameters[AGGREGATE_STACK_TYPES_PARAMETER_NAME]; }
     }
 
@@ -80,9 +93,17 @@
     }
 
-
     public override IOperation Apply() {
       var config = PushConfigurationParameter.ActualValue;
       var integerVectors = IntegerVectorParameter.ActualValue;
-      var pushPrograms = integerVectors.Select(iv => iv.ToPushProgram(config));
+
+      randomPool.Seed = config.Seed;
+
+      var pushPrograms = integerVectors.Select(iv => {
+        var random = randomPool.ResetAndAllocate();
+        var program = iv.ToPushProgram(config, random);
+        randomPool.Free(random);
+
+        return program;
+      });
 
       var results = ResultsParameter.ActualValue;
@@ -91,13 +112,13 @@
       if (frequencies == null) {
         frequencies = new DataTable(
-          "Instruction frequencies",
-          "Relative frequency of instructions aggregated over the whole population.") {
+          RESULT_PARAMETER_NAME,
+          RESULT_PARAMETER_DESCRIPTION) {
           VisualProperties = {
-            YAxisTitle = "Relative Instruction Frequency"
+            YAxisTitle = Y_AXIS_TITLE
           }
         };
 
         ExpressionFrequenciesParameter.ActualValue = frequencies;
-        results.Add(new Result("Instruction frequencies", frequencies));
+        results.Add(new Result(RESULT_PARAMETER_NAME, frequencies));
       }
 
@@ -110,7 +131,5 @@
 
       var expressionFrequencies = allExpressions
-        .GroupBy(x => AggregateStackTypes
-          ? x.Attribute.StackType.ToString()
-          : x.Attribute.Name)
+        .GroupBy(x => GetGroupName(x.Attribute, AggregateStackTypes))
         .ToDictionary(
           group => group.Key,
@@ -126,5 +145,5 @@
           var row = new DataRow(pair.Key, string.Empty, Enumerable.Repeat(0.0, numberOfValues)) {
             VisualProperties = {
-              StartIndexZero = true
+              StartIndexZero = true,
             }
           };
@@ -142,4 +161,14 @@
       return base.Apply();
     }
+
+    private string GetGroupName(PushExpressionAttribute attribute, bool aggregateStackTypes) {
+      if (aggregateStackTypes) {
+        return attribute.IsInExpression
+         ? IN_EXPRESSION_GROUP_NAME
+         : attribute.StackType.ToString();
+      }
+
+      return attribute.Name;
+    }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15273)
@@ -10,4 +10,5 @@
     public readonly string Name;
     public readonly string Description;
+    public readonly int? InExpressionNr;
 
     /// <summary>
@@ -32,5 +33,6 @@
       StackTypes additionalStackDependencies = default(StackTypes),
       uint execIn = 0,
-      bool isHidden = false) {
+      bool isHidden = false,
+      int inExpressionNr = -1) {
 
       StackType = stackType;
@@ -40,6 +42,9 @@
       ExecIn = execIn;
       IsHidden = isHidden;
+      InExpressionNr = inExpressionNr > 0 ? inExpressionNr : default(int?);
       ManipulatesExec = stackType == StackTypes.Exec || AdditionalStackDependencies.HasFlag(StackTypes.Exec);
     }
+
+    public bool IsInExpression { get { return this.InExpressionNr.HasValue; } }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs	(revision 15273)
@@ -17,11 +17,16 @@
   }
 
-  public interface IEnabledExpressionsConfiguration : INamedItem {
+  public interface IReadOnlyExpressionsConfiguration : INamedItem {
+    int InExpressionCount { get; }
+
+    IReadOnlyList<string> EnabledExpressions { get; }
+    IReadOnlyDictionary<StackTypes, int> ExpressionsPerStackCount { get; }
+  }
+
+  public interface IExpressionsConfiguration : IReadOnlyExpressionsConfiguration {
     event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
 
-    IReadOnlyList<string> EnabledExpressions { get; }
-
     void EnableStack(StackTypes types, bool enableDependencies = false);
-    void DisableStack(StackTypes type, bool enableDepenencies = false);
+    void DisableStack(StackTypes type, bool enableDependencies = false);
     void SetStack(StackTypes type, bool state, bool setDependencies = false);
     void EnableExpressionOfStack(StackTypes types);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15273)
@@ -2,11 +2,9 @@
   using System.Collections.Generic;
   using Base.Erc;
-  using Common;
-
-  using HeuristicLab.Core;
 
   using Stack;
 
-  public interface IReadOnlyPushConfiguration : IItem {
+  public interface IReadOnlyPushConfiguration : IReadOnlyExpressionsConfiguration {
+    int Seed { get; }
     int EvalPushLimit { get; }
     int MaxDepth { get; }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15273)
@@ -12,5 +12,5 @@
 
   [StorableClass]
-  public abstract class PushConfigurationBase : NamedItem, IEnabledExpressionsConfiguration {
+  public abstract class PushConfigurationBase : NamedItem, IExpressionsConfiguration {
 
     protected PushConfigurationBase() {
@@ -28,8 +28,18 @@
       enabledExpressions = origin.EnabledExpressions.ToList();
       expressionsPerStackCount = origin.expressionsPerStackCount.ToDictionary(x => x.Key, x => x.Value);
-    }
+      InExpressionCount = origin.InExpressionCount;
+      Seed = origin.Seed;
+    }
+
+    [Storable]
+    public int Seed { get; set; }
+
+    [Storable]
+    public int InExpressionCount { get; private set; }
 
     [Storable]
     private readonly Dictionary<StackTypes, int> expressionsPerStackCount;
+
+    public IReadOnlyDictionary<StackTypes, int> ExpressionsPerStackCount { get { return expressionsPerStackCount; } }
 
     public event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
@@ -112,9 +122,11 @@
 
     private void EnableExpressions(IEnumerable<string> expressionNames) {
-      foreach (var expressionName in expressionNames.Except(EnabledExpressions))
+      var addedExpressions = expressionNames as IList<string> ?? expressionNames.ToList();
+
+      foreach (var expressionName in addedExpressions.Except(EnabledExpressions))
         EnableExpression(expressionName, false);
 
       if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(expressionNames, new string[0]));
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(addedExpressions, new string[0]));
       }
     }
@@ -133,9 +145,11 @@
 
     private void DisableExpressions(IEnumerable<string> expressionNames) {
-      foreach (var expressionName in expressionNames.Intersect(EnabledExpressions))
+      var removedExpressions = expressionNames as IList<string> ?? expressionNames.ToList();
+
+      foreach (var expressionName in removedExpressions.Intersect(EnabledExpressions))
         DisableExpression(expressionName, false);
 
       if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(new string[0], expressionNames));
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(new string[0], removedExpressions));
       }
     }
@@ -229,4 +243,25 @@
       else DisableStack(type, setDependencies);
     }
+
+    public void InitInExpressions(int totalInputArgumentCount) {
+      InExpressionCount = totalInputArgumentCount;
+
+      for (var i = 0; i < ExpressionTable.InExpressionTable.Count; i++) {
+        var expression = ExpressionTable.InExpressionTable[i];
+        var expressionName = ExpressionTable.TypeToNameTable[expression.GetType()];
+
+        DisableExpression(expressionName);
+      }
+
+      if (totalInputArgumentCount > ExpressionTable.InExpressionTable.Count)
+        throw new InvalidOperationException("More input arguments defined as InExpression types");
+
+      for (var i = 0; i < totalInputArgumentCount; i++) {
+        var expression = ExpressionTable.InExpressionTable[i];
+        var expressionName = ExpressionTable.TypeToNameTable[expression.GetType()];
+
+        EnableExpression(expressionName);
+      }
+    }
   }
 }
